
function cgilua.statefile()
  local dir, statefilename
  local newtmpname
  local _, nfiles
  local contents

--  dir = cgilua.splitpath( tmpname() )
--  statefilename = dir .. "/states.cgilua" 

--  if readfrom( statefilename ) then
--    contents = read(".*")
--    readfrom()
--    _, nfiles = gsub( contents, "\n", "" )
--  else
--    nfiles = 0
--  end
--
--  if nfiles >= cgilua.max_states then
--    local temp = gsub( contents, "([^\n]*)\n", "remove('%1')\n", cgilua.nstates_remove )
--    local i, f, rem, keep = strfind( temp, "(.*%))\n([^)]*)" )
--    print( rem )
--    dostring( rem )
--    writeto( statefilename )
--    write( keep )
--    writeto()
--  end

  newtmpname = tmpname()..".cgilua"
--  appendto( statefilename )
--  write( newtmpname .. '\n' )
--  writeto()

  return newtmpname
end

function cgilua.getvalue( value )
  local t = type( value )

  if t == "nil" then return "nil" 
  elseif t == "number" then return value
  elseif t == "string" then return format( "%q", value) 
  elseif t == "table"  then return cgilua.maketable( value )
  else return "nil"
  end
end

function cgilua.maketable( t )
  local f,v = next( t, nil )
  local s = "{" 

  while f do 
    s = s..format( "\n  [%s] = %s,", cgilua.getvalue( f ), cgilua.getvalue( v ) )
    f, v = next( t, f )
  end
  return s.."\n}"
end

function cgilua.stateerrormethod( s )
  cgilua.error( format( "Lua error saving state information.<br>%s", s ) )
end

function cgilua.saveluavar( name )
  local luavar = dostring( "return "..name, cgilua.stateerrormethod )
  write( format( "%s = %s\n", name, cgilua.getvalue( luavar ) ) )
end


function cgilua.savestate( ... )
  local i = 1
  local curr_out = _OUTPUT

  if arg.n == 0 then return nil end

  local file = cgilua.statefile()
  if not writeto( file ) then
    cgilua.error( "Cannot write state information to file <CODE>%s</CODE>.",
                   file )
  end

  while i <= arg.n do
    cgilua.saveluavar( arg[i] )
    i = i + 1
  end

  writeto()
  _OUTPUT = curr_out
  return file
end

